Index: XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_redistribute.cpp
===================================================================
--- XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_redistribute.cpp	(revision 2507)
+++ XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_redistribute.cpp	(revision 2507)
@@ -0,0 +1,258 @@
+/*!
+   \file domain_algorithm_redistribute.cpp
+   \brief Algorithm for redistribute a domain.
+ */
+#include "domain_algorithm_redistribute.hpp"
+#include "redistribute_domain.hpp"
+#include "domain.hpp"
+#include "grid.hpp"
+#include "grid_transformation_factory_impl.hpp"
+#include "context.hpp"
+
+namespace xios
+{
+
+  shared_ptr<CGenericAlgorithmTransformation> CDomainAlgorithmRedistribute::create(bool isSource, CGrid* gridDst, CGrid* gridSrc,
+                                                               CTransformation<CDomain>* transformation,
+                                                               int elementPositionInGrid,
+                                                               std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                               std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                               std::map<int, int>& elementPositionInGridSrc2DomainPosition, 
+                                                               std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                               std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                               std::map<int, int>& elementPositionInGridDst2DomainPosition)
+  TRY
+  {
+    std::vector<CDomain*> domainListDestP = gridDst->getDomains();
+    std::vector<CDomain*> domainListSrcP  = gridSrc->getDomains();
+
+    CRedistributeDomain* redistributeDomain = dynamic_cast<CRedistributeDomain*> (transformation);
+    int domainDstIndex = elementPositionInGridDst2DomainPosition[elementPositionInGrid];
+    int domainSrcIndex = elementPositionInGridSrc2DomainPosition[elementPositionInGrid];
+
+    return make_shared<CDomainAlgorithmRedistribute>(isSource, domainListDestP[domainDstIndex], domainListSrcP[domainSrcIndex], redistributeDomain);
+  }
+  CATCH
+
+  bool CDomainAlgorithmRedistribute::dummyRegistered_ = CDomainAlgorithmRedistribute::registerTrans();
+  bool CDomainAlgorithmRedistribute::registerTrans()
+  TRY
+  {
+    return CGridTransformationFactory<CDomain>::registerTransformation(TRANS_REDISTRIBUTE_DOMAIN, create);
+  }
+  CATCH
+
+  CDomainAlgorithmRedistribute::CDomainAlgorithmRedistribute(bool isSource, CDomain* domainDestination, CDomain* domainSource, CRedistributeDomain* redistributeDomain)
+  : CAlgorithmTransformationTransfer(isSource)
+  TRY
+  {
+     CContext* context = CContext::getCurrent(); 
+   // Reset geometrical attributes to avoid incompatible (user/domainSource) attributs
+   //   attributs will be defined using domainSource and/or transformation attributs
+    domainDestination->type.reset();
+    domainDestination->ni_glo.reset();
+    domainDestination->nj_glo.reset();
+   
+    domainDestination->i_index.reset();   // defined using domainSource->getLocalElement()
+    domainDestination->j_index.reset();   // "
+    domainDestination->ibegin.reset();    // will be computed in domainDestination->checkDomain() (from checkAttributes())
+    domainDestination->ni.reset();        // "
+    domainDestination->jbegin.reset();    // "
+    domainDestination->nj.reset();        // "
+   
+    domainDestination->mask_1d.reset();   // defined scanning domainSource->getFullView() & domainSource->getWorkflowView() differencies
+    domainDestination->mask_2d.reset();   //   in all case domainDestination->mask_1d used as reference  
+
+    // domainDestination->data_* attributes will be computed in :
+    domainDestination->data_dim.reset();     // domainDestination->checkDomainData() (from checkAttributes())
+    domainDestination->data_ni.reset();
+    domainDestination->data_nj.reset();
+    domainDestination->data_ibegin.reset();
+    domainDestination->data_jbegin.reset();
+    domainDestination->data_i_index.reset(); // domainDestination->checkCompression() (from checkAttributes())
+    domainDestination->data_j_index.reset();
+
+    // Next attributes will be set using domainSource->attributes 
+    domainDestination->lonvalue_1d.reset();
+    domainDestination->latvalue_1d.reset();
+    domainDestination->lonvalue_2d.reset();
+    domainDestination->latvalue_2d.reset();
+    domainDestination->nvertex.reset();
+    domainDestination->bounds_lon_1d.reset();
+    domainDestination->bounds_lat_1d.reset();
+    domainDestination->bounds_lon_2d.reset();
+    domainDestination->bounds_lat_2d.reset();
+    domainDestination->area.reset();
+    domainDestination->radius.reset();
+
+    auto& index = redistributeDomain-> index ;
+    
+    domainDestination->type = domainSource->type ;
+    domainDestination-> ni_glo = domainSource-> ni_glo ;
+    domainDestination-> nj_glo = domainSource-> nj_glo ;
+    
+    CArray<size_t,1> globalIndex ;
+    int start_i, start_j ;
+    int size_i, size_j ;
+    int ni_glo = domainDestination-> ni_glo ;
+    int nj_glo = domainDestination-> nj_glo ;
+    
+       
+    if (redistributeDomain->type == CRedistributeDomain::type_attr::index)
+    {   
+      globalIndex.resize(index.numElements()) ;
+      globalIndex=index ;
+    }
+    else
+    {
+      
+      auto distType = CRedistributeDomain::type_attr::column ;
+      
+      if (redistributeDomain->type == CRedistributeDomain::type_attr::bands && domainDestination->type == CDomain::type_attr::unstructured) 
+        distType = CRedistributeDomain::type_attr::column ;
+      else  distType=redistributeDomain->type;
+
+      if (distType==CRedistributeDomain::type_attr::bands) // Bands distribution to send to file server
+      {
+        int nbClient = context->getIntraCommSize() ;
+        int rankClient = context->getIntraCommRank() ;
+      
+        int size = nj_glo/nbClient ;
+        int start ;
+        if (rankClient < nj_glo % nbClient)
+        {
+         size++ ;
+         start = rankClient*size ;
+        }
+        else start = (nj_glo % nbClient)*(size+1) + (rankClient-(nj_glo % nbClient)) * size ;
+
+        size_i=ni_glo ; start_i=0 ;
+        size_j=size ; start_j=start ;
+      }
+      else if (distType==CRedistributeDomain::type_attr::column) // Bands distribution to send to file server
+      {
+        int nbClient = context->getIntraCommSize() ;
+        int rankClient = context->getIntraCommRank() ;
+      
+        int size = ni_glo/nbClient ;
+        int start ;
+
+        if (rankClient < ni_glo % nbClient)
+        {
+         size++ ;
+         start = rankClient*size ;
+        }
+        else start = (ni_glo % nbClient)*(size+1) + (rankClient-(ni_glo % nbClient)) * size ;
+
+        size_i=size ; start_i=start ;
+        size_j=nj_glo ; start_j=0 ;
+      }
+      else if (distType==CRedistributeDomain::type_attr::full) // domain is not distributed ie all servers get the same local domain
+      {
+        size_i=ni_glo ; start_i=0 ;
+        size_j=nj_glo ; start_j=0 ;
+      }
+      else if (distType==CRedistributeDomain::type_attr::root) // domain is not distributed ie all servers get the same local domain
+      {
+        if (context->getIntraCommRank()==0)
+        {
+          size_i=ni_glo ; start_i=0 ;
+          size_j=nj_glo ; start_j=0 ;
+        }
+        else
+        {
+          size_i=0 ; start_i=0 ;
+          size_j=0 ; start_j=0 ;
+        }  
+      }
+      globalIndex.resize(size_i*size_j) ;
+      size_t ind ;
+      ind=0 ;
+      for(int j=start_j;j<start_j+size_j;j++)
+        for(int i=start_i;i<start_i+size_i;i++)
+        {
+         globalIndex(ind) =  j*ni_glo+i ;
+         ind++ ;
+        }
+    }
+
+
+    //domainDestination->ni = globalIndex.numElements() ;
+    //domainDestination->nj = 1 ;
+    domainDestination->i_index.resize(globalIndex.numElements()) ;
+    domainDestination->i_index = globalIndex ;
+    domainDestination->j_index.resize(globalIndex.numElements()) ;
+    domainDestination->j_index = 0 ;
+    
+    if (!domainSource->nvertex.isEmpty()) domainDestination->nvertex=domainSource->nvertex ;
+    if (!domainSource->radius.isEmpty()) domainDestination->radius = domainSource->radius ;
+    
+
+    auto& transMap = this->transformationMapping_;
+    for(int i=0; i<globalIndex.numElements(); i++) transMap[globalIndex(i)]=globalIndex(i) ;
+    
+    auto elementDst=shared_ptr<CLocalElement>(new CLocalElement(context->getIntraCommRank(),domainDestination-> ni_glo*domainDestination->nj_glo, globalIndex)) ;
+    elementDst->addFullView() ;
+
+    auto transformConnector = make_shared<CTransformConnector>(domainSource->getLocalView(CElementView::FULL), elementDst->getView(CElementView::FULL),context->getIntraComm()) ;
+    transformConnector->computeConnector() ;
+
+    if (domainSource->hasLonLat)
+    {
+      transformConnector->transfer(domainSource->lonvalue, domainDestination->lonvalue_1d) ;
+      transformConnector->transfer(domainSource->latvalue, domainDestination->latvalue_1d) ;
+    }
+
+    if (domainSource->hasBounds)
+    {
+      int nv ;
+      if (domainDestination->type == CDomain::type_attr::rectilinear) nv=2 ;
+      else if (domainDestination->type == CDomain::type_attr::curvilinear) nv=4 ;
+      else if (domainDestination->type == CDomain::type_attr::unstructured) nv=domainDestination->nvertex ;
+
+      { // bounds_lon
+        CArray<double,1> boundsSrc(domainSource->bounds_lonvalue.dataFirst(),shape(domainSource->bounds_lonvalue.numElements()),neverDeleteData) ;
+        CArray<double,1> boundsDst ; 
+        transformConnector->transfer(nv, boundsSrc, boundsDst) ;
+        domainDestination->bounds_lon_1d.resize(nv,globalIndex.numElements()) ;
+        domainDestination->bounds_lon_1d = CArray<double,2>(boundsDst.dataFirst(), shape(nv,globalIndex.numElements()),neverDeleteData) ;
+      }
+      {  // bounds_lat
+        CArray<double,1> boundsSrc(domainSource->bounds_latvalue.dataFirst(),shape(domainSource->bounds_latvalue.numElements()),neverDeleteData) ;
+        CArray<double,1> boundsDst ; 
+        transformConnector->transfer(nv, boundsSrc, boundsDst) ;
+        domainDestination->bounds_lat_1d.resize(nv,globalIndex.numElements()) ;
+        domainDestination->bounds_lat_1d = CArray<double,2>(boundsDst.dataFirst(), shape(nv,globalIndex.numElements()),neverDeleteData) ;
+      }
+    }
+    
+    if (domainSource->hasArea) transformConnector->transfer(domainSource->areavalue, domainDestination->area_1d) ; 
+
+    // transfer the mask
+     auto transformMask = make_shared<CTransformConnector>(domainSource->getLocalView(CElementView::WORKFLOW), elementDst->getView(CElementView::FULL),context->getIntraComm()) ;
+    transformMask->computeConnector() ;
+
+    CArray<bool,1> workflow(domainSource->getLocalView(CElementView::WORKFLOW)->getSize()) ;
+    domainDestination->mask_1d.resize(domainSource->getLocalView(CElementView::FULL)->getSize()) ;
+    workflow=true ;
+    
+    transformMask->transfer(workflow,domainDestination->mask_1d,false) ;   
+/*
+    CArray<int,1> workflow(domainSource->getLocalView(CElementView::WORKFLOW)->getSize()) ;
+    CArray<int,1> mask(domainSource->getLocalView(CElementView::FULL)->getSize()) ;
+    workflow=1 ;
+    
+    transformMask->transfer(workflow,mask,0) ;
+    domainDestination->mask_1d.resize(mask.numElements()) ;
+    for(int i=0 ; i<mask.numElements() ; i++) 
+      if (mask(i)==1) domainDestination->mask_1d(i)=true ;
+      else domainDestination->mask_1d(i)=false ;
+*/  
+
+    domainDestination->checkAttributes() ;
+    this->computeAlgorithm(domainSource->getLocalView(CElementView::WORKFLOW), domainDestination->getLocalView(CElementView::WORKFLOW)) ;
+  }
+  CATCH
+
+
+}
Index: XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_redistribute.hpp
===================================================================
--- XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_redistribute.hpp	(revision 2507)
+++ XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_redistribute.hpp	(revision 2507)
@@ -0,0 +1,45 @@
+/*!
+   \brief Algorithm for redistributing domain.
+ */
+#ifndef __XIOS_DOMAIN_ALGORITHM_REDISTRIBUTE_HPP__
+#define __XIOS_DOMAIN_ALGORITHM_REDISTRIBUTE_HPP__
+
+#include "algorithm_transformation_transfer.hpp"
+#include "transformation.hpp"
+
+namespace xios 
+{
+
+  class CDomain;
+  class CRedistributeDomain;
+
+  /*!
+    \class CDomainAlgorithmReorder
+    Redistribute data on domain
+  */
+  class CDomainAlgorithmRedistribute : public CAlgorithmTransformationTransfer  
+  {
+    public:
+      CDomainAlgorithmRedistribute(bool isSource, CDomain* domainDestination, CDomain* domainSource, CRedistributeDomain* redistributeDomain);
+
+      virtual ~CDomainAlgorithmRedistribute() {}
+
+      static bool registerTrans();
+      virtual StdString getAlgoName() {return "\\nredistribute_domain";}
+
+  
+    public:
+      static shared_ptr<CGenericAlgorithmTransformation> create(bool isSource, CGrid* gridDst, CGrid* gridSrc,
+                                                     CTransformation<CDomain>* transformation,
+                                                     int elementPositionInGrid,
+                                                     std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                     std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                     std::map<int, int>& elementPositionInGridSrc2DomainPosition,
+                                                     std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                     std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                     std::map<int, int>& elementPositionInGridDst2DomainPosition);
+      static bool dummyRegistered_;
+};
+
+}
+#endif // __XIOS_DOMAIN_ALGORITHM_REDISTRIBUTE_HPP__
Index: XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_reorder.cpp
===================================================================
--- XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_reorder.cpp	(revision 2498)
+++ XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_reorder.cpp	(revision 2507)
@@ -128,6 +128,6 @@
    else if (!domainSource->lonvalue_2d.isEmpty() )
    {
-     domainDestination->latvalue_2d.resize( domainSource->latvalue_2d.numElements() );
-     domainDestination->lonvalue_2d.resize( domainSource->lonvalue_2d.numElements() );
+     domainDestination->latvalue_2d.resize( domainSource->latvalue_2d.shape() );
+     domainDestination->lonvalue_2d.resize( domainSource->lonvalue_2d.shape() );
      domainDestination->latvalue_2d = domainSource->latvalue_2d;
      domainDestination->lonvalue_2d = domainSource->lonvalue_2d;
@@ -145,15 +145,21 @@
    else if (!domainSource->bounds_lon_2d.isEmpty() )
    {
-     domainDestination->bounds_lon_2d.resize( domainSource->bounds_lon_2d.numElements() );
-     domainDestination->bounds_lat_2d.resize( domainSource->bounds_lat_2d.numElements() );
+     domainDestination->bounds_lon_2d.resize( domainSource->bounds_lon_2d.shape() );
+     domainDestination->bounds_lat_2d.resize( domainSource->bounds_lat_2d.shape() );
      domainDestination->bounds_lon_2d = domainSource->bounds_lon_2d;
      domainDestination->bounds_lat_2d = domainSource->bounds_lat_2d;
    }
    // set area
-   if (!domainSource->area.isEmpty() )
-   {
-     domainDestination->area.resize( domainSource->area.numElements() );
-     domainDestination->area = domainSource->area;    
-   }
+   if (!domainSource->area_1d.isEmpty() )
+   {
+     domainDestination->area_1d.resize( domainSource->area_1d.numElements() );
+     domainDestination->area_1d = domainSource->area_1d;    
+   }
+   else if (!domainSource->area_2d.isEmpty() )
+   {
+     domainDestination->area_2d.resize( domainSource->area_2d.shape() );
+     domainDestination->area_2d = domainSource->area_2d;    
+   }
+
    if (!domainSource->radius.isEmpty() )
      domainDestination->radius = domainSource->radius;
Index: XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_zoom.cpp
===================================================================
--- XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_zoom.cpp	(revision 2498)
+++ XIOS3/trunk/src/transformation/domain_algorithm/domain_algorithm_zoom.cpp	(revision 2507)
@@ -173,6 +173,9 @@
     }
   }
-  if (domainSrc_->hasArea) domainDest_->area.resize(niDest,njDest);
-
+  if (domainSrc_->hasArea)
+  {
+    if (!domainSrc_->area_1d.isEmpty()) domainDest_->area_1d.resize(niDest*njDest);
+    else if (!domainSrc_->area_2d.isEmpty()) domainDest_->area_2d.resize(niDest,njDest);
+  }
 
   for (int iDest = 0; iDest < niDest; iDest++)
@@ -196,5 +199,8 @@
 
       if (domainSrc_->hasArea)
-        domainDest_->area(iDest,jDest) = domainSrc_->area(iSrc,jSrc);
+      {  
+         if (!domainSrc_->area_1d.isEmpty())      domainDest_->area_1d(indLocDest)  = domainSrc_->area_1d(ind);
+         else if (!domainSrc_->area_2d.isEmpty()) domainDest_->area_2d(iDest,jDest) = domainSrc_->area_2d(iSrc,jSrc);
+      }
 
       if (domainSrc_->hasLonLat)
Index: XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_extract_axis.cpp
===================================================================
--- XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_extract_axis.cpp	(revision 2498)
+++ XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_extract_axis.cpp	(revision 2507)
@@ -108,5 +108,5 @@
     }
 
-    if (axisSource->hasValue)
+    if (axisSource->hasValue())
     {
       scalarDestination->value = axisSource->value(idxSrc);
Index: XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_redistribute.cpp
===================================================================
--- XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_redistribute.cpp	(revision 2507)
+++ XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_redistribute.cpp	(revision 2507)
@@ -0,0 +1,133 @@
+/*!
+   \file scalar_algorithm_redistribute.cpp
+   \brief Algorithm for redistribute a scalar.
+ */
+#include "scalar_algorithm_redistribute.hpp"
+#include "redistribute_scalar.hpp"
+#include "scalar.hpp"
+#include "grid.hpp"
+#include "grid_transformation_factory_impl.hpp"
+#include "context.hpp"
+
+namespace xios
+{
+
+  shared_ptr<CGenericAlgorithmTransformation> CScalarAlgorithmRedistribute::create(bool isSource, CGrid* gridDst, CGrid* gridSrc,
+                                                               CTransformation<CScalar>* transformation,
+                                                               int elementPositionInGrid,
+                                                               std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                               std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                               std::map<int, int>& elementPositionInGridSrc2DomainPosition, 
+                                                               std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                               std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                               std::map<int, int>& elementPositionInGridDst2DomainPosition)
+  TRY
+  {
+    std::vector<CScalar*> scalarListDestP = gridDst->getScalars();
+    std::vector<CScalar*> scalarListSrcP  = gridSrc->getScalars();
+
+    CRedistributeScalar* redistributeScalar = dynamic_cast<CRedistributeScalar*> (transformation);
+    int scalarDstIndex = elementPositionInGridDst2ScalarPosition[elementPositionInGrid];
+    int scalarSrcIndex = elementPositionInGridSrc2ScalarPosition[elementPositionInGrid];
+
+    return make_shared<CScalarAlgorithmRedistribute>(isSource, scalarListDestP[scalarDstIndex], scalarListSrcP[scalarSrcIndex], redistributeScalar);
+  }
+  CATCH
+
+  bool CScalarAlgorithmRedistribute::dummyRegistered_ = CScalarAlgorithmRedistribute::registerTrans();
+  bool CScalarAlgorithmRedistribute::registerTrans()
+  TRY
+  {
+    return CGridTransformationFactory<CScalar>::registerTransformation(TRANS_REDISTRIBUTE_SCALAR, create);
+  }
+  CATCH
+
+  CScalarAlgorithmRedistribute::CScalarAlgorithmRedistribute(bool isSource, CScalar* scalarDestination, CScalar* scalarSource, CRedistributeScalar* redistributeScalar)
+  : CAlgorithmTransformationTransfer(isSource)
+  TRY
+  {
+
+    CContext* context = CContext::getCurrent(); 
+
+    scalarDestination->n.reset();
+    scalarDestination->mask.reset();
+    scalarDestination->value.reset();
+    scalarDestination->bounds.reset();
+
+    redistributeScalar->checkValid(scalarSource);
+
+    // define the global index of the new domain
+
+    CArray<size_t,1> globalIndex ;
+
+    if (    redistributeScalar->type == CRedistributeScalar::type_attr::bands 
+         || redistributeScalar->type == CRedistributeScalar::type_attr::column 
+         || redistributeScalar->type == CRedistributeScalar::type_attr::root )
+    {
+      if (context->getIntraCommRank()==0)
+      {
+        scalarDestination->n = 1;
+        globalIndex.resize(1) ;
+        globalIndex(0)=0 ;
+      }
+      else
+      {
+        scalarDestination->n = 0;
+        globalIndex.resize(0) ;
+      }
+    }
+    else if (redistributeScalar->type == CRedistributeScalar::type_attr::full)
+    {
+      scalarDestination->n = 1;
+      globalIndex.resize(1) ;
+      globalIndex(0)=0 ;
+    }
+    
+    auto& transMap = this->transformationMapping_;
+    for(int i=0; i<globalIndex.numElements(); i++) transMap[globalIndex(i)]=globalIndex(i) ;
+
+    auto elementDst=shared_ptr<CLocalElement>(new CLocalElement(context->getIntraCommRank(), 1, globalIndex)) ;
+    elementDst->addFullView() ;
+
+    auto transformConnector = make_shared<CTransformConnector>(scalarSource->getLocalView(CElementView::FULL), elementDst->getView(CElementView::FULL),context->getIntraComm()) ;
+    transformConnector->computeConnector() ;
+
+    CArray<double,1> valSrc, valDst ;
+    valSrc.resize(scalarSource->getLocalView(CElementView::FULL)->getSize()) ;
+    valDst.resize(scalarDestination->getLocalView(CElementView::FULL)->getSize()) ;
+    
+    if (scalarSource->hasValue())
+    {
+      if (valSrc.numElements()>0)  valSrc(0)=scalarSource->value ;
+      transformConnector->transfer(valSrc, valDst) ;
+      if (valDst.numElements()>0)  scalarDestination->value = valDst(0) ;
+    }
+
+    if (scalarSource->hasBounds()) 
+    {
+      transformConnector->transfer(2, scalarSource->bounds, scalarDestination->bounds) ;
+    }
+    
+    if (scalarSource->hasLabel())
+    {
+//ym transferTransformConnector.transfer(axisSrc->label, axisDestination->label) ;  -> probably not supported now, see later
+    }
+
+    // transfer the mask
+    auto transformMask = make_shared<CTransformConnector>(scalarSource->getLocalView(CElementView::WORKFLOW), elementDst->getView(CElementView::FULL),context->getIntraComm()) ;
+    transformMask->computeConnector() ;
+
+    CArray<bool,1> workflow(scalarSource->getLocalView(CElementView::WORKFLOW)->getSize()) ;
+    CArray<bool,1> mask ;
+    mask.resize(scalarSource->getLocalView(CElementView::FULL)->getSize()) ;
+    workflow=true ;
+    
+    transformMask->transfer(workflow, mask, false) ;   
+    scalarDestination->mask = mask(0) ;
+
+    scalarDestination->checkAttributes() ;
+  }
+  CATCH
+
+
+}
Index: XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_redistribute.hpp
===================================================================
--- XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_redistribute.hpp	(revision 2507)
+++ XIOS3/trunk/src/transformation/scalar_algorithm/scalar_algorithm_redistribute.hpp	(revision 2507)
@@ -0,0 +1,45 @@
+/*!
+   \brief Algorithm for redistributing scalar.
+ */
+#ifndef __XIOS_SCALAR_ALGORITHM_REDISTRIBUTE_HPP__
+#define __XIOS_SCALAR_ALGORITHM_REDISTRIBUTE_HPP__
+
+#include "algorithm_transformation_transfer.hpp"
+#include "transformation.hpp"
+
+namespace xios 
+{
+
+  class CScalar;
+  class CRedistributeScalar;
+
+  /*!
+    \class CDomainAlgorithmReorder
+    Redistribute data on domain
+  */
+  class CScalarAlgorithmRedistribute : public CAlgorithmTransformationTransfer  
+  {
+    public:
+      CScalarAlgorithmRedistribute(bool isSource, CScalar* scalarDestination, CScalar* scalarSource, CRedistributeScalar* redistributeScalar);
+
+      virtual ~CScalarAlgorithmRedistribute() {}
+
+      static bool registerTrans();
+      virtual StdString getAlgoName() {return "\\nredistribute_scalar";}
+
+  
+    public:
+      static shared_ptr<CGenericAlgorithmTransformation> create(bool isSource, CGrid* gridDst, CGrid* gridSrc,
+                                                     CTransformation<CScalar>* transformation,
+                                                     int elementPositionInGrid,
+                                                     std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                     std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                     std::map<int, int>& elementPositionInGridSrc2DomainPosition,
+                                                     std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                     std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                     std::map<int, int>& elementPositionInGridDst2DomainPosition);
+      static bool dummyRegistered_;
+};
+
+}
+#endif // __XIOS_SCALAR_ALGORITHM_REDISTRIBUTE_HPP__
Index: XIOS3/trunk/src/transformation/transformation_enum.hpp
===================================================================
--- XIOS3/trunk/src/transformation/transformation_enum.hpp	(revision 2498)
+++ XIOS3/trunk/src/transformation/transformation_enum.hpp	(revision 2507)
@@ -26,5 +26,8 @@
         TRANS_REORDER_DOMAIN = 17,
         TRANS_EXTRACT_DOMAIN = 18,
-        TRANS_EXTRACT_AXIS = 19
+        TRANS_EXTRACT_AXIS = 19,
+        TRANS_REDISTRIBUTE_DOMAIN = 20,
+        TRANS_REDISTRIBUTE_AXIS = 21,
+        TRANS_REDISTRIBUTE_SCALAR = 22
       } ETranformationType;
 
Index: XIOS3/trunk/src/transport/context_client.cpp
===================================================================
--- XIOS3/trunk/src/transport/context_client.cpp	(revision 2498)
+++ XIOS3/trunk/src/transport/context_client.cpp	(revision 2507)
@@ -18,4 +18,6 @@
 #include "one_sided_context_client.hpp"
 #include "legacy_context_client.hpp"
+#include "online_context_client.hpp"
+
 
 namespace xios
@@ -61,4 +63,5 @@
       if (defaultProtocol=="one_sided") return getNew<CContextClient::oneSided>(parent, intraComm, interComm) ;
       else if  (defaultProtocol=="legacy") return getNew<CContextClient::legacy>(parent, intraComm, interComm) ;
+      else if  (defaultProtocol=="online") return getNew<CContextClient::online>(parent, intraComm, interComm) ;
       else if  (defaultProtocol=="default") return getNew<CContextClient::legacy>(parent, intraComm, interComm) ;
       else ERROR("CContextClient* CContextClient::getNew<CContextClient::generic>(CContext* parent, MPI_Comm intraComm, MPI_Comm interComm, CContext* parentServer)",
@@ -76,4 +79,10 @@
     { 
       return new CLegacyContextClient(parent, intraComm, interComm, parentServer); 
+    }
+
+    template<>
+    CContextClient* CContextClient::getNew<CContextClient::online>(CContext* parent, MPI_Comm intraComm, MPI_Comm interComm, CContext* parentServer)
+    { 
+      return new COnlineContextClient(parent, intraComm, interComm, parentServer); 
     }
 
Index: XIOS3/trunk/src/transport/context_client.hpp
===================================================================
--- XIOS3/trunk/src/transport/context_client.hpp	(revision 2498)
+++ XIOS3/trunk/src/transport/context_client.hpp	(revision 2507)
@@ -28,5 +28,5 @@
   {
     public:
-      enum ETransport { generic, legacy, oneSided}  ;
+      enum ETransport { generic, legacy, oneSided, online}  ;
       
       template<ETransport transport=generic> 
@@ -56,4 +56,5 @@
 
 
+      virtual ETransport getType(void) = 0 ;
       // Send event to server
       virtual void sendEvent(CEventClient& event)=0;
@@ -68,5 +69,6 @@
       virtual void setBufferSize(const std::map<int,StdSize>& mapSize)=0;
 
-
+      public: 
+        static CContextClient* ONLINE(void) { return reinterpret_cast<CContextClient*>(0xdeaddead);}
     protected:
 
@@ -104,4 +106,7 @@
   CContextClient* CContextClient::getNew<CContextClient::legacy>(CContext* parent, MPI_Comm intraComm, MPI_Comm interComm, CContext* parentServer) ;
 
+  template<>
+  CContextClient* CContextClient::getNew<CContextClient::online>(CContext* parent, MPI_Comm intraComm, MPI_Comm interComm, CContext* parentServer) ;
+
 
 }
Index: XIOS3/trunk/src/transport/legacy_context_client.cpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_client.cpp	(revision 2498)
+++ XIOS3/trunk/src/transport/legacy_context_client.cpp	(revision 2507)
@@ -40,4 +40,5 @@
     }
 
+    CContextClient::ETransport getType(void) {return CContextClient::legacy ;}
 
     /*!
Index: XIOS3/trunk/src/transport/legacy_context_client.hpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_client.hpp	(revision 2498)
+++ XIOS3/trunk/src/transport/legacy_context_client.hpp	(revision 2507)
@@ -31,4 +31,5 @@
 
       // Send event to server
+      ETransport getType(void) {return legacy ;}
       void sendEvent(CEventClient& event);
       void eventLoop(void) ;
